library pc_plugins;
import 'dart:typed_data';

import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/material.dart';

import 'bg.dart';


const double defaultAvSize=90;

class ava extends StatelessWidget {
  final String? url;
  final bool rect;
  final double size;
  final Uint8List? data;
  final bool loading;
  final Widget? child;
  final Color? shadowColor;
  final Color? uploadIconColor;
  final Widget Function(Widget)? uploaderBuilder;
  final bool showUploadIcon;
  final bool useCached;
  final BorderSide hightlight;

  const ava({this.url,this.data,this.rect = false, this.size = defaultAvSize,
    this.shadowColor,this.uploadIconColor,this.uploaderBuilder,
    this.hightlight=BorderSide.none,this.useCached=true,
    this.loading=false, this.child, this.showUploadIcon=false,Key? key}):super(key: key);

  @override
  Widget build(BuildContext context) {
    final image=loading?const Loading():
    (url??"").isEmpty?
    (data==null?(child??Icon(Icons.account_circle, size: size)):
    Image.memory(data!,fit: BoxFit.cover)):
    useCached?CachedNetworkImage(
      imageUrl: url!,
      progressIndicatorBuilder: (context, url, downloadProgress) =>
          CircularProgressIndicator(value: downloadProgress.progress),
      errorWidget: (context, url, error) => const Icon(Icons.error),
    ):
    Image.network(
      url!,
      fit: BoxFit.cover,
    );
    return Stack(
      children: [
        Card(
          elevation: 5,
          shadowColor: shadowColor,
          shape: rect
              ? RoundedRectangleBorder(borderRadius: BorderRadius.circular(size/3.2), side: hightlight)
              : CircleBorder(side: hightlight),
          clipBehavior: Clip.antiAlias,
          child: SizedBox(
            width: size,
            height: size,
            child: image,
          ),
        ),
        if(showUploadIcon)_buildUpload()
      ],
    );
  }

  _buildUpload(){
    final child=MouseRegion(cursor: SystemMouseCursors.click,
        child: Icon(Icons.upload_rounded,color: uploadIconColor,size: size/4));
    return Positioned(top: 3, right: 3,
        child: Container(decoration: const BoxDecoration(color: Colors.white, shape: BoxShape.circle, boxShadow: [BoxShadow(color: Colors.black45, blurRadius: 5)]),
            child: uploaderBuilder==null?child:uploaderBuilder!(child)));
  }
}
